// mainview.cpp : implementation file
//
//
// Copyright (c) 1995 by R. E. Frazier - all rights reserved
//
// This program and source provided for example purposes.  You may
// redistribute it so long as no modifications are made to any of
// the source files, and the above copyright notice has been 
// included.  You may also use portions of the sample code in your
// own programs, as desired.

#include "stdafx.h"
#include "sortdemo.h"
#include "mainview.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


// STATIC DATA GOES HERE

int pData[256]={0};
COLORREF pColor[N_DIMENSIONS(pData)]={0};



/////////////////////////////////////////////////////////////////////////////
// CMainView

// IMPLEMENT_DYNCREATE(CMainView, CView)

CMainView::CMainView()
{
}

CMainView::~CMainView()
{
}


BEGIN_MESSAGE_MAP(CMainView, CView)
	//{{AFX_MSG_MAP(CMainView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMainView drawing

void CMainView::OnDraw(CDC* pDC)
{
UINT ui1;
RECT rct;
CPen cpenBlack(PS_SOLID,1,RGB(0,0,0));

   WaitForSingleObject(theApp.m_hSortMutex, INFINITE);

   GetClientRect(&rct);
   CPen *cpenOld = pDC->SelectObject(&cpenBlack);
   pDC->Rectangle(rct.left, rct.top, rct.right, rct.bottom);

   for(ui1=0; ui1<N_DIMENSIONS(pData); ui1++)
   {
      RePaintLine(ui1, pDC);
   }

   pDC->SelectObject(cpenOld);

   ReleaseMutex(theApp.m_hSortMutex);
}

void CMainView::RePaintLine(UINT uiIndex, CDC *pDC)
{
CPen cpenWhite(PS_SOLID,1,RGB(255,255,255));
CPen cpen(PS_SOLID,1,pColor[uiIndex]);
CDC *pDC2;
RECT rct;

   GetClientRect(&rct);

   if(!pDC) pDC2 = GetDC();
   else     pDC2 = pDC;

   CPen *cpenOld = pDC2->SelectObject(&cpen);
   pDC2->MoveTo(rct.left + 2,rct.top + 2 + uiIndex);
   pDC2->LineTo(rct.left + 2 + pData[uiIndex], rct.top + 2 + uiIndex);
   pDC2->SelectObject(&cpenWhite);
   pDC2->LineTo(rct.right - 2,rct.top + 2 + uiIndex);

   pDC2->SelectObject(cpenOld);

   if(pDC != pDC2) ReleaseDC(pDC2);

}


/////////////////////////////////////////////////////////////////////////////
// CMainView diagnostics

#ifdef _DEBUG
void CMainView::AssertValid() const
{
	CView::AssertValid();
}

void CMainView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainView message handlers

void CMainView::PostNcDestroy() 
{
	// TODO: Add your specialized code here and/or call the base class
	
//	CView::PostNcDestroy();  // do *NOT* call this!  it deletes 'this'
                            // and is only valid if I'm allocated
                            // from the heap, which I am not.
}
