// sortdemo.cpp : Defines the class behaviors for the application.
//
// Copyright (c) 1995 by R. E. Frazier - all rights reserved
//
// This program and source provided for example purposes.  You may
// redistribute it so long as no modifications are made to any of
// the source files, and the above copyright notice has been 
// included.  You may also use portions of the sample code in your
// own programs, as desired.


#include "stdafx.h"
#include "sortdemo.h"
#include "mainview.h"
#include "mainfrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSortdemoApp

BEGIN_MESSAGE_MAP(CSortdemoApp, CWinApp)
	//{{AFX_MSG_MAP(CSortdemoApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(IDM_SORT_NEWDATA, OnSortNewdata)
	ON_COMMAND(IDM_SORT_RESTORE, OnSortRestore)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSortdemoApp construction

CSortdemoApp::CSortdemoApp()
{
   m_hSortThread = INVALID_HANDLE_VALUE;
   m_hSortMutex = INVALID_HANDLE_VALUE;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSortdemoApp object

CSortdemoApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSortdemoApp initialization

BOOL CSortdemoApp::InitInstance()
{
CString csCaption;

	Enable3dControls();

  m_hSortMutex = CreateMutex(NULL, FALSE, "SortMutex");
  if(m_hSortMutex == INVALID_HANDLE_VALUE)
  {
    return(0);  // fail the load
  }

  csCaption.LoadString(IDR_MAINFRAME);

  m_pMainWnd = (CWnd *)(new CMainFrame);
  ((CMainFrame *)m_pMainWnd)->
     Create(AfxRegisterWndClass(CS_HREDRAW | CS_VREDRAW, 0, 0, 
                                ::LoadIcon(m_hInstance, MAKEINTRESOURCE(IDR_MAINFRAME))),
                                csCaption, 
                                WS_OVERLAPPEDWINDOW,
                                CRect(CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT),
                                NULL, MAKEINTRESOURCE(IDR_MAINFRAME));
   
  m_pMainWnd->ShowWindow(m_nCmdShow);
  m_pMainWnd->SetWindowPos(NULL, -1, -1, 420, 380, 0);

	OnSortNewdata();

	if (m_lpCmdLine[0] != '\0')
	{
		// TODO: add command line processing here
	}

	return(TRUE);  // load OK!
}

int CSortdemoApp::ExitInstance() 
{
   if(m_hSortThread != INVALID_HANDLE_VALUE) 
   {
      TerminateThread(m_hSortThread, 0);  // end it, now!
   }

   if(m_hSortMutex != INVALID_HANDLE_VALUE)
   {
      CloseHandle(m_hSortMutex);
      m_hSortMutex = INVALID_HANDLE_VALUE;
   }	

	return CWinApp::ExitInstance();
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CSortdemoApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CSortdemoApp commands

int irand(int iMax)
{
  return((int)((double)rand() * iMax / RAND_MAX));
}

COLORREF GetLineColor(UINT uiIndex)
{
double d5PIover3= 5 * 3.1415926538 / 3;
double dRoot3 = sqrt(3.0);
double dX, dY, dSinX, dCosX, dR, dG, dB;

   // NOTE:  5 * PI / 3 corresponds to VIOLET to give me a rainbow

   dX = (d5PIover3 * pData[uiIndex]) / N_DIMENSIONS(pData);

   dSinX = sin(dX);
   dCosX = cos(dX);
   
   if(dSinX == 0 && dCosX >= 0)
   {
      dR = 1;
      dG = 0;
      dB = 0;
   }
   else if(dSinX > 0 && dCosX == -.5)
   {
      dR = 0;
      dG = 1;
      dB = 0;
   }
   else if(dSinX < 0 && dCosX == -.5)
   {
      dR = 0;
      dG = 0;
      dB = 1;
   }
   else if(dSinX > 0 && dCosX > -.5) // RG
   {
      // vector sum of R and G as follows:
      // R sin(r) + G sin(g) = X sin(x)
      // R cos(r) + G cos(g) = X cos(x)
      //
      // ASSUME 'X' = 1
      //
      // R * 0 + G * sqrt(3)/2 = dSinX
      // R * 1 + G * -.5 = dCosX

      dB = 0;
      dG = dSinX * 2 / dRoot3;
      dR = dCosX + dG * .5;
   }
   else if(dSinX < 0 && dCosX > -.5)  // RB
   {
      // vector sum of R and G as follows:
      // R sin(r) + B sin(b) = X sin(x)
      // R cos(r) + B cos(b) = X cos(x)
      //
      // ASSUME 'X' = 1
      //
      // R * 0 + B * -sqrt(3)/2 = dSinX
      // R * 1 + B * -.5 = dCosX

      dG = 0;
      dB = - dSinX * 2 / dRoot3;
      dR = dCosX + dB * .5;
   }
   else                                // GB
   {
      // vector sum of R and G as follows:
      // G sin(g) + B sin(b) = X sin(x)
      // G cos(g) + B cos(b) = X cos(x)
      //
      // ASSUME 'X' = 1
      //
      // G * sqrt(3)/2 + B * -sqrt(3)/2 = dSinX
      // G * -.5 + B * -.5 = dCosX
      //
      // G = dSinX * 2 / sqrt(3) + B
      //
      // G + B = -2dCosX
      // B = -(2 * dCosX + G)
      //
      // B = -(2 * dCosX + dSinX * 2 / sqrt(3) + B)
      // 2B = -2 * dCosX - dSinX * 2 / sqrt(3)
      // B = -dCosX - dSinX / sqrt(3)

      dR = 0;
      dB = -dCosX - dSinX / dRoot3;
      dG = dSinX * 2 / dRoot3 + dB;
   }

   dY = 255 / sqrt(dB * dB + dG * dG + dR * dR);

   return(RGB((int)(dY * dR),(int)(dY * dG),(int)(dY * dB)));
}    


static int pData0[N_DIMENSIONS(pData)];
static COLORREF pColor0[N_DIMENSIONS(pData)];

void CSortdemoApp::OnSortNewdata() 
{
UINT ui1;

   srand(GetTickCount());

   for(ui1=0; ui1<N_DIMENSIONS(pData); ui1++)
   {
     pData[ui1] = irand(N_DIMENSIONS(pData));
     pData0[ui1] = pData[ui1];

     pColor[ui1] = GetLineColor(ui1);
     pColor0[ui1] = pColor[ui1];
   }

   ((CMainFrame *)m_pMainWnd)->m_wndMainView.InvalidateRect(NULL, TRUE);
}

void CSortdemoApp::OnSortRestore() 
{
UINT ui1;

   for(ui1=0; ui1<N_DIMENSIONS(pData); ui1++)
   {
     pData[ui1] = pData0[ui1];
     pColor[ui1] = pColor0[ui1];
   }

   ((CMainFrame *)m_pMainWnd)->m_wndMainView.InvalidateRect(NULL, TRUE);
}

